/* Implementation of Microchip USB lib. debugging output routines
 * using stdio. Enabled with DEBUG_MODE defined.
 */
#ifdef DEBUG_MODE
#include <debug.h>
#include <xc.h>
#include <stdio.h>

void DEBUG_Initialize()
{
  /* UART initialisation is performed automatically in uart_debug.c */
  printf ("USB library debugging output enabled\r\n");
}

void DEBUG_PutChar(char c)
{
  putchar(c);
}

void DEBUG_PutString(char* data)
{
  puts(data);
}

void DEBUG_PutHexUINT32(UINT32 data)
{
  puts("[32-bit int]");
}

void DEBUG_PutHexUINT16(UINT16 data)
{
  printf("0x%X", data);
}

void DEBUG_PutHexUINT8(UINT8 data)
{
  DEBUG_PutHexUINT16((UINT16)data);
}
#endif
