/* UART2 serial debugging output for stdout (printf) */

#include <xc.h>

/** UART ***********************************************************/
//#define BAUDRATE2       57600UL
#define BAUDRATE2	9600UL
#define BRG_DIV2        16
#define BRGH2           0                     // Standard-Speed mode

/** CLK ************************************************************/
//#define CLOCK_FREQ 8000000
#define CLOCK_FREQ 32000000
#define GetSystemClock() CLOCK_FREQ
#define GetPeripheralClock() CLOCK_FREQ

//U2BRG register value and baudrate mistake calculation
#if defined (__C30__)
    #if defined (__dsPIC33E__) || defined (__PIC24E__)
    #define BAUDRATEREG2        (((GetPeripheralClock())/(BRG_DIV2 * BAUDRATE2)) - 1)
    #else
    #define BAUDRATEREG2        (((GetSystemClock()/2)+(BRG_DIV2/2*BAUDRATE2))/BRG_DIV2/BAUDRATE2-1)
    #endif
#elif defined (__PIC32MX__)
    #define BAUDRATEREG2        ((GetPeripheralClock()+(BRG_DIV2/2*BAUDRATE2))/BRG_DIV2/BAUDRATE2-1)
#else
    #error Cannot calculate BRG value
#endif

/* Based on DS50001456L-page 37
 * Replaces write in Microchip libc. */

int __attribute__((__section__(".libc.write")))
  write(int handle, void *buffer, unsigned int len) {
  int i;
/*
  switch (handle)
  {
  default:
  case 0:
  case 1:
  case 2:
*/
     if ((U2MODEbits.UARTEN) == 0)
     {
//        U2BRG = 0; /* Baud rate = 0? - sets to maximum possible */
        U2BRG = BAUDRATEREG2;
        U2MODEbits.STSEL = 1;                    // 2-Stop bit
        U2MODEbits.PDSEL = 0;                    // No Parity, 8-Data bits
        U2MODEbits.ABAUD = 0;                    // Auto-Baud disabled
        U2MODEbits.BRGH = BRGH2;                 // Set speed mode
        U2MODEbits.UARTEN = 1;                   // UART enabled
     }
     if ((U2STAbits.UTXEN) == 0)
     {
        U2STAbits.UTXEN = 1;                     // Enable UART TX
     }
     for (i = len; i; --i)
     {
        while ((U2STAbits.TRMT) == 0);
        U2TXREG = *(char*)buffer++;
     }
/*
  }
*/
  return(len);
}
